"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.override = override;
exports.before = before;
exports.after = after;
/**
 * Based on http://me.dt.in.th/page/JavaScript-override
 */
function override(object, methodName, callback) {
  object[methodName] = callback(object[methodName]);
}

function before(extraBehavior) {
  return function (original) {
    return function () {
      return original.apply(this, extraBehavior.apply(this, arguments));
    };
  };
}

function after(extraBehavior) {
  return function (original) {
    return function () {
      return extraBehavior.call(this, original.apply(this, arguments), arguments);
    };
  };
}